/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// FlowWriteAction - struct for FlowWriteAction
type FlowWriteAction struct {
	WriteAction *WriteAction
}

// WriteActionAsFlowWriteAction is a convenience function that returns WriteAction wrapped in FlowWriteAction
func WriteActionAsFlowWriteAction(v *WriteAction) FlowWriteAction {
	return FlowWriteAction{
		WriteAction: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *FlowWriteAction) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into WriteAction
	err = newStrictDecoder(data).Decode(&dst.WriteAction)
	if err == nil {
		jsonWriteAction, _ := json.Marshal(dst.WriteAction)
		if string(jsonWriteAction) == "{}" { // empty struct
			dst.WriteAction = nil
		} else {
			match++
		}
	} else {
		dst.WriteAction = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.WriteAction = nil

		return fmt.Errorf("data matches more than one schema in oneOf(FlowWriteAction)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(FlowWriteAction)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src FlowWriteAction) MarshalJSON() ([]byte, error) {
	if src.WriteAction != nil {
		return json.Marshal(&src.WriteAction)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *FlowWriteAction) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.WriteAction != nil {
		return obj.WriteAction
	}

	// all schemas are nil
	return nil
}

type NullableFlowWriteAction struct {
	value *FlowWriteAction
	isSet bool
}

func (v NullableFlowWriteAction) Get() *FlowWriteAction {
	return v.value
}

func (v *NullableFlowWriteAction) Set(val *FlowWriteAction) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowWriteAction) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowWriteAction) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowWriteAction(val *FlowWriteAction) *NullableFlowWriteAction {
	return &NullableFlowWriteAction{value: val, isSet: true}
}

func (v NullableFlowWriteAction) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowWriteAction) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
